module CuratedDatasets

using DocStringExtensions
# using LinearAlgebra
# using Statistics
using Requires
# using CSV
using DataFrames
using OpenML
# using UCIData     # > via Requires
using MLJ
# using Distances
#
export load_dataset,
       download_datasets, 
       download_OpenML_datasets, 
       download_uci_datasets
export median_pairwise_Euclidean,
       median_pairwise_Euclidean_standardized,
       get_n,
       get_d,
       get_source

include("./utils.jl")
include("./uci_nodeps.jl")
include("./open_ml.jl")

function __init__()
    #  Not sure why but compilation fails when adding UCIData as a dependency
	@require UCIData="2dacb708-9dd8-11e9-1001-07df1c52a9e4" begin
        using .UCIData
        include("./uci.jl")
		@require Revise="295af30f-e4ad-537b-8983-00126c2a3abe" begin
			using .Revise
            Revise.track(SGDSamplingStrategies, joinpath(@__DIR__, "uci.jl"))
		end
    end
end
end # module CuratedDatasets
