uci_name(name) = haskey(UCI[name], :uci_name) ? UCI[name][:uci_name] : name

# todo: some could could be factorized with OpenML
function load_uci_dataset(::Type{DataFrame}, name;
                            max_samples = Inf,
                            kwargs...)
    @assert name in keys(UCI)
    dst = UCI[name]
    df = UCIData.dataset(uci_name(name))
    if haskey(dst, :ignore)
        select!(df, Not(dst[:ignore]))
    end
    df = custom_coerce(df, (haskey(dst, :coercion_rules) ? dst[:coercion_rules] : Dict()))
    (max_samples < Inf) && delete!(df, (max_samples+1):nrow(df))
    df = standardize(df, dst[:target]; kwargs...) 
    X, y = custom_unpack(df, dst[:target])
    return X, y
end

load_uci_dataset(name) = load_dataset(Matrix, name)

function download_uci_datasets()
    for (n,d) in pairs(UCI)
        _ = load_uci_dataset(n)
    end
end
